"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shortcuts = exports.recording = exports.basicSetup = void 0;
const autocomplete_1 = require("@codemirror/autocomplete");
const closebrackets_1 = require("@codemirror/closebrackets");
const commands_1 = require("@codemirror/commands");
const comment_1 = require("@codemirror/comment");
const fold_1 = require("@codemirror/fold");
const gutter_1 = require("@codemirror/gutter");
const highlight_1 = require("@codemirror/highlight");
const history_1 = require("@codemirror/history");
const language_1 = require("@codemirror/language");
const lint_1 = require("@codemirror/lint");
const matchbrackets_1 = require("@codemirror/matchbrackets");
const rectangular_selection_1 = require("@codemirror/rectangular-selection");
const search_1 = require("@codemirror/search");
const state_1 = require("@codemirror/state");
const view_1 = require("@codemirror/view");
exports.basicSetup = [
    (0, gutter_1.lineNumbers)(),
    (0, gutter_1.highlightActiveLineGutter)(),
    (0, view_1.highlightSpecialChars)(),
    (0, history_1.history)(),
    (0, fold_1.foldGutter)(),
    (0, view_1.drawSelection)(),
    (0, view_1.dropCursor)(),
    state_1.EditorState.allowMultipleSelections.of(true),
    (0, language_1.indentOnInput)(),
    highlight_1.defaultHighlightStyle.fallback,
    (0, matchbrackets_1.bracketMatching)(),
    (0, closebrackets_1.closeBrackets)(),
    (0, autocomplete_1.autocompletion)(),
    (0, rectangular_selection_1.rectangularSelection)(),
    // highlightActiveLine(),
    (0, search_1.highlightSelectionMatches)(),
    view_1.keymap.of([
        ...closebrackets_1.closeBracketsKeymap,
        commands_1.indentWithTab,
        ...commands_1.defaultKeymap,
        ...search_1.searchKeymap,
        ...history_1.historyKeymap,
        ...fold_1.foldKeymap,
        ...comment_1.commentKeymap,
        ...autocomplete_1.completionKeymap,
        ...lint_1.lintKeymap
    ])
];
exports.recording = new state_1.Compartment;
exports.shortcuts = new state_1.Compartment;
